xCrop = 1:100;
yCrop = 24:44;
zCrop = 140:210;

a = rekon3DZ(yCrop,xCrop,zCrop);
b = rekon3DX(yCrop,xCrop,zCrop);

[~, i] = max(a(:));
[iy,ix,iz] = ind2sub([size(a,1), size(a,2), size(a,3)], i);

axialProfZ = squeeze(a(iy,ix,:));
lateralProfZ = squeeze(a(:,ix,iz));
elevationProfZ = squeeze(a(iy,:,iz));

axialGausZ = fit(zCrop'*Settings.sampleDepth, axialProfZ, 'gauss1');
lateralGausZ = fit(yCrop'*Settings.pitch, lateralProfZ, 'gauss1');
elevationGausZ = fit(xCrop'*Settings.sampleDepth, elevationProfZ', 'gauss1');

axialResZ = 2*sqrt(log(2))*axialGausZ.c1;
lateralResZ = 2*sqrt(log(2))*lateralGausZ.c1;
elevationResZ = 2*sqrt(log(2))*elevationGausZ.c1;

figure

subplot(3,1,1)
plot(zCrop'*Settings.sampleDepth, axialProfZ, 'o');
hold on
plot(axialGausZ)
hold off
xlim([zCrop(1) zCrop(end)]*Settings.sampleDepth);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{axial} = ' num2str(axialResZ) ' mm']);
subplot(3,1,2)
plot(yCrop'*Settings.pitch, lateralProfZ, 'o')
hold on
plot(lateralGausZ)
hold off
xlim([yCrop(1) yCrop(end)]*Settings.pitch);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{lateral} = ' num2str(lateralResZ) ' mm']);
subplot(3,1,3)
plot(xCrop'*Settings.sampleDepth, elevationProfZ, 'o')
hold on
plot(elevationGausZ)
hold off
xlim([xCrop(1) xCrop(end)]*Settings.sampleDepth);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{elevation} = ' num2str(elevationResZ) ' mm']);

[~, i] = max(b(:));
[iy,ix,iz] = ind2sub([size(b,1), size(b,2), size(b,3)], i);

axialProfX = squeeze(b(iy,ix,:));
lateralProfX = squeeze(b(:,ix,iz));
elevationProfX = squeeze(b(iy,:,iz));

axialGausX = fit(zCrop'*Settings.sampleDepth, axialProfX, 'gauss1');
lateralGausX = fit(yCrop'*Settings.pitch, lateralProfX, 'gauss1');
elevationGausX = fit(xCrop'*Settings.sampleDepth, elevationProfX', 'gauss1');

axialResX = 2*sqrt(log(2))*axialGausX.c1;
lateralResX = 2*sqrt(log(2))*lateralGausX.c1;
elevationResX = 2*sqrt(log(2))*elevationGausX.c1;

figure

subplot(3,1,1)
plot(zCrop'*Settings.sampleDepth, axialProfX, 'o');
hold on
plot(axialGausX)
hold off
xlim([zCrop(1) zCrop(end)]*Settings.sampleDepth);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{axial} = ' num2str(axialResX) ' mm']);
subplot(3,1,2)
plot(yCrop'*Settings.pitch, lateralProfX, 'o')
hold on
plot(lateralGausX)
hold off
xlim([yCrop(1) yCrop(end)]*Settings.pitch);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{lateral} = ' num2str(lateralResX) ' mm']);
subplot(3,1,3)
plot(xCrop'*Settings.sampleDepth, elevationProfX, 'o')
hold on
plot(elevationGausX)
hold off
xlim([xCrop(1) xCrop(end)]*Settings.sampleDepth);
xlabel('');
ylabel('');
legend('profile', 'gaussian fitted');
title(['FWHM_{elevation} = ' num2str(elevationResX) ' mm']);