function deprocessedImg = deprocess_peaks_v2(processedImg, preprocessedImg)
% sharpens the objects in the input image
% scans the image along rows and columns, find the peaks (signal) sharpens
% those peaks

nRows = size(processedImg, 1);
nCols = size(processedImg, 2);
cutOff = 0.0;

%% scan along columns
rowImg = preprocessedImg';    
rowImg = reshape(rowImg, 1, []);   
deprocessedRowImg = zeros(size(rowImg));

rowProcessedImg = processedImg';    
rowProcessedImg = reshape(rowProcessedImg, 1, []); 
[peaks, peakIds] = findpeaks(rowProcessedImg); % find peaks
peakScanCnt = 0;
% scan around the peak, cut out the pixel smaller than the cutOff
for iPeak = 1:length(peakIds)
    peakIdx = peakIds(iPeak);
    iCol = ceil(peakIdx/nCols);
    tempCutOff = cutOff*peaks(iPeak);
    scanIdxLim1 = nCols*iCol+1;
    scanIdxLim2 = nCols*(iCol-1);
    peakScanCnt = 0;
    while peakIdx+peakScanCnt+1 < scanIdxLim1 && rowImg(peakIdx+peakScanCnt+1) > tempCutOff
        if rowImg(peakIdx+peakScanCnt+1) < rowImg(peakIdx+peakScanCnt)
            peakScanCnt = peakScanCnt + 1;
        else
            scanIdxLim1 = 0;            
        end        
    end
    peakEnd = peakIdx+peakScanCnt;
    peakScanCnt = 0;
    while peakIdx-peakScanCnt-1 > scanIdxLim2 && rowImg(peakIdx-peakScanCnt-1) > tempCutOff
        if rowImg(peakIdx-peakScanCnt-1) < rowImg(peakIdx-peakScanCnt)
            peakScanCnt = peakScanCnt + 1;
        else
            scanIdxLim2 = nCols*nRows+1;
        end
        
    end
    peakStart = peakIdx-peakScanCnt;
    deprocessedRowImg(peakStart:peakEnd) = rowImg(peakStart:peakEnd);
end
deprocessedRowImg = reshape(deprocessedRowImg, nCols, nRows);
deprocessedRowImg = deprocessedRowImg';
deprocessedRowImg = reshape(deprocessedRowImg, 1, []);
colImg = reshape(preprocessedImg, 1, []);

%% scan along rows
deprocessedImg = zeros(size(colImg));
[peaks, peakIds] = findpeaks(deprocessedRowImg);
for iPeak = 1:length(peakIds)
    peakIdx = peakIds(iPeak);
    iCol = ceil(peakIdx/nRows);
    tempCutOff = cutOff*peaks(iPeak);
    scanIdxLim1 = nRows*iCol+1;
    scanIdxLim2 = nRows*(iCol-1);
    peakScanCnt = 0;
    while peakIdx+peakScanCnt+1 < scanIdxLim1 && colImg(peakIdx+peakScanCnt+1) > tempCutOff 
        if colImg(peakIdx+peakScanCnt+1) < colImg(peakIdx+peakScanCnt)
            peakScanCnt = peakScanCnt + 1;
        else
            scanIdxLim1 = 0;
        end
        
    end
    peakEnd = peakIdx+peakScanCnt;
    peakScanCnt = 0;
    while peakIdx-peakScanCnt-1 > scanIdxLim2 && colImg(peakIdx-peakScanCnt-1) > tempCutOff
        if colImg(peakIdx-peakScanCnt-1) < colImg(peakIdx-peakScanCnt)
            peakScanCnt = peakScanCnt + 1;
        else
            scanIdxLim2 = nCols*nRows+1;
        end
        
    end
    peakStart = peakIdx-peakScanCnt;
    deprocessedImg(peakStart:peakEnd) = colImg(peakStart:peakEnd);
end
deprocessedImg = reshape(deprocessedImg, nRows, nCols);
