function processedImg = process_peaks_v2(PreProObjects, cutOff)
% sharpens the objects in the input image
% scans the image along rows and columns, find the peaks (signal) sharpens
% those peaks

objImg = PreProObjects.objectsShow;
imgSize = size(objImg);
nRows = imgSize(1);
nCols = imgSize(2);
colImg = reshape(objImg, 1, []);
processedColImg = zeros(size(colImg));
% objImg = reshape(objImg,[],1);
% for iCol = 1:nCols
%     colImg = objImg(:, iCol);
%     tempCol = zeros(1, nRows);
    [peaks, peakIds] = findpeaks(colImg); % find peaks
    % scan around the peak, cut out the pixels which have values smaller 
    % than the cutOff
    peakScanCnt = 0;
    for iPeak = 1:length(peakIds)
        peakIdx = peakIds(iPeak);
        iCol = ceil(peakIdx/nRows);
        tempCutOff = cutOff*peaks(iPeak);
        scanIdxLim1 = nRows*iCol+1;
        scanIdxLim2 = nRows*(iCol-1);
        peakScanCnt = 0;
        while peakIdx+peakScanCnt+1 < scanIdxLim1 && colImg(peakIdx+peakScanCnt+1) > tempCutOff
            if colImg(peakIdx+peakScanCnt+1) < colImg(peakIdx+peakScanCnt)
                peakScanCnt = peakScanCnt + 1;
            else
%                 peakScanCnt = peakScanCnt -1;                    
                scanIdxLim1 = peakIdx;
            end
            
        end
        peakEnd = peakIdx+peakScanCnt;
        peakScanCnt = 0;
        while peakIdx-peakScanCnt-1 > scanIdxLim2 && colImg(peakIdx-peakScanCnt-1) > tempCutOff 
                if colImg(peakIdx-peakScanCnt-1) < colImg(peakIdx-peakScanCnt)
                    peakScanCnt = peakScanCnt + 1;
                else
%                     peakScanCnt = peakScanCnt - 1; 
                    scanIdxLim2 = nRows*nCols+1;
                end                
        end
        peakStart = peakIdx-peakScanCnt;
        processedColImg(peakStart:peakEnd) = colImg(peakStart:peakEnd);
    end
processedColImg = reshape(processedColImg, nRows, nCols);
processedColImg = processedColImg';
rowImg = reshape(processedColImg, 1, []);
% end

%% scan along rows
processedImg = zeros(size(rowImg));
% for iRow = 1:nRows
%     rowImg = processedColImg(iRow, :);
%     tempRow = zeros(1, nCols);
    [peaks, peakIds] = findpeaks(rowImg);
    for iPeak = 1:length(peakIds)
        peakIdx = peakIds(iPeak);
        iCol = ceil(peakIdx/nCols);
        tempCutOff = cutOff*peaks(iPeak);
        scanIdxLim1 = nCols*iCol+1;
        scanIdxLim2 = nCols*(iCol-1);
        peakScanCnt = 0;
        while peakIdx+peakScanCnt+1 < scanIdxLim1 && rowImg(peakIdx+peakScanCnt+1) > tempCutOff
            if rowImg(peakIdx+peakScanCnt+1) < rowImg(peakIdx+peakScanCnt)
                peakScanCnt = peakScanCnt + 1;
            else
%                 peakScanCnt = peakScanCnt -1;                    
                scanIdxLim1 = peakIdx;
            end            
        end
        peakEnd = peakIdx+peakScanCnt;
        peakScanCnt = 0;
        while peakIdx-peakScanCnt-1 > scanIdxLim2 && rowImg(peakIdx-peakScanCnt-1) > tempCutOff
            if rowImg(peakIdx-peakScanCnt-1) < rowImg(peakIdx-peakScanCnt)
                peakScanCnt = peakScanCnt + 1;
            else
%                 peakScanCnt = peakScanCnt -1;                    
                scanIdxLim2 = nRows*nCols+1;
            end            
        end
        peakStart = peakIdx-peakScanCnt;
        processedImg(peakStart:peakEnd) = rowImg(peakStart:peakEnd);        
    end
processedImg = reshape(processedImg, nCols, nRows);
processedImg = processedImg';
% end
% figure
% imagesc(processedImg)
% colormap hot
