dataPath = 'P:\TNW\BMPI\Users\Ho Nhu Y Nguyen\Published papers\3D view of out-of-plane artifacts\data';
fnEts = '_FFT.mat'; % file name extension. 3D projections will be
                    % saved under a new name as dataFileName_fnEts
                    % i.e. dataFileName is
                    % 'two-absorbers_20205018_155003.rfe'
                    % then the name of that 3D projection will be 
                    % 'two-absorbers_20205018_155003_FFT.mat'
system = 2; % the PAI system used to record data
            % 1: MyLabOne with a no-laser probe
            % 2: MyLabOne with a laser-integrated probe
            % 3: Eagle
dispStepX = 0.525; % [mm]. Check in notes.txt in the data folder
dispStepZ = 0.525; % [mm]
save3DProjection = 0; % save 3D projections or not
                      % 1: yes
                      % else: no
% select all x and z displacement data files
[fn,fp] = uigetfile('*.rfe','Select PA data sets','MultiSelect','on',dataPath);
fn = fn';
nFiles = length(fn);
% these 2 lines below will separate x and z displacement data files,
% process the file name, and extract the displacement steps
[fnX,dispX,newFnX] = process_fileName_3D(fn,fnEts,system,2,dispStepX);
[fnZ,dispZ,newFnZ] = process_fileName_3D(fn,fnEts,system,1,dispStepZ);
if save3DProjection==1
    % create 3D projections
    create_multi_3D_data(fp,fnX,system,2,dispX,save3DProjection,newFnX);
    create_multi_3D_data(fp,fnZ,system,1,dispZ,save3DProjection,newFnZ);
end
% the following if end is to read the data acquisition settings of the
% transducer array
if system==1 % myLabOne with a no-laser probe
    [~,Settings] = read_process_noLaser([fp fn{1}],0,-1);
elseif system==2 % MyLabOne
    Settings = read_data_myLabOne([fp fn{1}],0,-1);
elseif system==3 % Eagle
    [Settings,Data] = read_raw_data_eagle([fp fn{1}],0,-1);
    [signal,Settings] = preprocess_data_PA_Eagle(Settings,Data);
end
% reconstruct all 3D projections
isRecon = input('reconstruct 3D images? ("1":yes, else:no): ');
if isRecon==1
    [rekon3DX,rekon3DCalX] = recon_3D(fp,newFnX,Settings,2,dispX);
    [rekon3DZ,rekon3DCalZ] = recon_3D(fp,newFnZ,Settings,1,dispZ);
end
