function Objects = segment_image(clearestImg, Settings)

[~, threshold] = edge(clearestImg(Settings.PA.cutOffIdx1+1:end-...
    Settings.PA.cutOffHalfIdx-1,:),'sobel'); % find a threshold for defining
                                             % edge of Objects using sobel
objectsEdge = edge(clearestImg,'sobel', threshold*0.5); % detect Objects edge

se90 = strel('line', 2, 90);
se0 = strel('line', 2, 0);
objectsEdge = imdilate(objectsEdge, [se90 se0]); % connect outline of the Objects
objectsImg = imfill(objectsEdge, 'holes'); % fill holes in Objects

%% with peak process
PreProObjects = bwconncomp(objectsImg, 4); % find Objects
PreProObjects.objectsShow = zeros(size(clearestImg));
PreProObjects.PixelIdxList(cellfun('length',PreProObjects.PixelIdxList) < 3) = [];
PreProObjects.allObjPxls = cat(1, PreProObjects.PixelIdxList{:});
PreProObjects.objectsShow(PreProObjects.allObjPxls) = clearestImg(PreProObjects.allObjPxls);
Settings.peakCutOff = 0.7;
processedPeakImg = process_peaks_v2(PreProObjects, Settings.peakCutOff);
Objects = bwconncomp(processedPeakImg, 4); % find Objects

%% without peak process
% Objects = bwconncomp(objectsImg, 4); % find Objects

%% obtain objects
Objects.PixelIdxList(cellfun('length',Objects.PixelIdxList) < 3) = [];
Objects.allObjPxls = cat(1, Objects.PixelIdxList{:});
Objects.objectsShow = zeros(size(clearestImg));
Objects.objectsShow(Objects.allObjPxls) = clearestImg(Objects.allObjPxls);
Objects.nObjs = length(Objects.PixelIdxList);
Objects.objPosX = cell(1, Objects.nObjs);
Objects.objPosY = cell(1, Objects.nObjs);
Objects.objHeight = zeros(1, Objects.nObjs);
Objects.objWidth = zeros(1, Objects.nObjs);
Objects.objPxlPosX = zeros(1, Objects.nObjs);
Objects.clearestImg = clearestImg;