% close all

%% read & process data
[Settings,Data] = read_data_myLabOne('P:\TNW\BMPI\Users\Ho Nhu Y Nguyen\Published papers\3D view of out-of-plane artifacts\data',0,0);
[signal,Settings,Data] = preprocess_data_PA_myLabOne(Settings,Data);
wavelengths = wavelength_event_converter(Settings.PA.events);
nEvents = length(Settings.PA.events);

%% reconstruct images
rekon = zeros(nEvents, Settings.PA.frameLength, Settings.finfo.nrl);
maxRekon = 0;
clearestImgIdx = 1; % to find the clearest image (highest signal)
figure
subplotRow = ceil(sqrt(nEvents));
subplotCol = ceil(nEvents/subplotRow);
for iEvent = 1:nEvents    
    tempRekon = rekon_OA_freqdom(squeeze(signal(iEvent,:,:)), Settings);
    rekon(iEvent,:,:) = tempRekon;
    if max(tempRekon(:)) > maxRekon
        maxRekon = max(tempRekon(:));
        clearestImgIdx = iEvent;
    end
    rekon(iEvent,:,:) = tempRekon;
    subplot(subplotRow, subplotCol, iEvent);
    imagesc(Settings.acqY, Settings.PA.acqDepth, tempRekon);
    axis image
    ylabel('depth [mm]');
    xlabel('y [mm]');
    colormap(hot);
    colorbar;
%     set(gca, 'CLim', [0, 130]);    
    title(['\lambda = ' wavelengths{iEvent} 'nm']);
end
fprintf('done!\n');
clearestImg = squeeze(rekon(clearestImgIdx, :, :));
tempFrame = squeeze(mean(Data.US.dataRF));
tempFrame(Settings.PA.cutOffIdx1+1:end-2*Settings.PA.cutOffHalfIdx-1,:)=...
    detrend(tempFrame(Settings.PA.cutOffIdx1+1:end-2*Settings.PA.cutOffHalfIdx-1,:), 'constant');
USFrame = rekon_US_freqdom_anglenew_compounding(tempFrame...
        ,Settings.acq.fs/1e6,Settings.pitch,Settings.c,2,0,0,5,1,1e9,0);
USFrame(274:721,:) = USFrame(253:700,:);
figure
% subplot(1,2,1)
% % imagesc(USFrame);
% imagesc(Settings.acqY, Settings.PA.acqDepth, USFrame);
% axis image
% ylabel('depth [mm]');
% xlabel('y [mm]');
% title('US image');
% colormap hot
% colorbar

% subplot(1,2,2)
% % imagesc(clearestImg)
imagesc(Settings.acqY, Settings.PA.acqDepth, clearestImg);
axis image
ylabel('depth [mm]');
xlabel('y [mm]');
title('Original image');
colormap hot
colorbar