function wavelengths = wavelength_event_converter(events)
% to convert the trigger event of acquired images to the wavelength
% wavelengths = wavelength_event_converter(events)
%  events: trigger events, they are normally binary numbers
%  wavelengths: wavelengths used to image
nEvents = length(events);
waveBase = {'808', '915', '940', '980'}; % hard code! Check the manual of 
                                         % each probe for the wavelengths
wavelengths = cell(1,nEvents);
for iEvent = 1:nEvents
    event = events(iEvent);
    is980 = floor(event/1000);
    is940 = floor((event-is980*1000)/100);
    is915 = floor((event-is980*1000-is940*100)/10);
    is808 = event-is980*1000-is940*100-is915*10;
%     waveIds = ids();
    waveFired = waveBase([logical(is808), logical(is915), logical(is940), logical(is980)]);
    wavelengths{iEvent} = strjoin(waveFired, ', ');
end